Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/asminc.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/asminc.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/asminc.F90	(revision 13906)
@@ -423,5 +423,9 @@
                      &            / e3t(ji,jj,jk,Kmm)
                END_2D
+#if defined key_mpi3
+               CALL lbc_lnk_nc_multi( 'asminc', zhdiv, 'T', 1. )   ! lateral boundary cond. (no sign change)
+#else
                CALL lbc_lnk( 'asminc', zhdiv, 'T', 1. )   ! lateral boundary cond. (no sign change)
+#endif
                !
                DO_2D( 0, 0, 0, 0 )
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/diawri.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/diawri.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/diawri.F90	(revision 13906)
@@ -184,5 +184,9 @@
                &                  + e3t(ji+1,jj,1,Kmm) * e1e2t(ji+1,jj)  ) * r1_e1e2u(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'U', 1._wp )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'U', 1._wp )
+#endif
          CALL iom_put( "hu", z2d ) 
       ENDIF
@@ -194,5 +198,9 @@
               &                    + e3t(ji,jj  ,1,Kmm) * e1e2t(ji,jj  )   ) * r1_e1e2v(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'V', 1._wp )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'V', 1._wp )
+#endif
          CALL iom_put( "hv", z2d )    
       ENDIF             
@@ -205,5 +213,9 @@
          END_2D
          z2d(:,:) = z2d(:,:) * ssfmask(:,:)
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1._wp )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1._wp )
+#endif
          CALL iom_put( "hf", z2d )   
       ENDIF              
@@ -224,5 +236,9 @@
             !
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'T', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'T', 1. )
+#endif
          CALL iom_put( "taubot", z2d )           
       ENDIF
@@ -243,5 +259,9 @@
          END_2D
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'T', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'T', 1. )
+#endif
          IF ( iom_use("sKE" ) )  CALL iom_put( "sKE" , z2d )   
                            
@@ -259,5 +279,9 @@
          END_2D
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
+#endif
          CALL iom_put( "sKEf", z2d )                     
       ENDIF
@@ -277,5 +301,9 @@
             &              - e1u(ji  ,jj+1) * uu(ji  ,jj+1,1,Kmm) + e1u(ji,jj) * uu(ji,jj,1,Kmm)  ) * r1_e1e2f(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
+#endif
          CALL iom_put( "relvor", z2d )                  ! relative vorticity ( zeta ) 
          !
@@ -290,5 +318,9 @@
             z2d(ji,jj) = ze3 * z2d(ji,jj) 
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
+#endif
          CALL iom_put( "relpotvor", z2d )                  ! relative potential vorticity (zeta/h)
          !
@@ -301,5 +333,9 @@
             z2d(ji,jj) = ze3 * ff_f(ji,jj) + z2d(ji,jj) 
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
+#endif
          CALL iom_put( "abspotvor", z2d )                  ! absolute potential vorticity ( q )
          !
@@ -307,5 +343,9 @@
             z2d(ji,jj) = 0.5_wp * z2d(ji,jj)  * z2d(ji,jj) 
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'diawri', z2d, 'F', 1. )
+#else
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
+#endif
          CALL iom_put( "Ens", z2d )                        ! potential enstrophy ( 1/2*q2 )
          !
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dommsk.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dommsk.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dommsk.F90	(revision 13906)
@@ -141,5 +141,9 @@
       ! the following call is mandatory
       ! it masks boundaries (bathy=0) where needed depending on the configuration (closed, periodic...)  
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dommsk', tmask  , 'T', 1._wp )      ! Lateral boundary conditions
+#else
       CALL lbc_lnk( 'dommsk', tmask  , 'T', 1._wp )      ! Lateral boundary conditions
+#endif
 
      ! Mask corrections for bdy (read in mppini2)
@@ -173,5 +177,9 @@
          END DO
       END DO
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dommsk', umask, 'U', 1., vmask, 'V', 1., fmask, 'F', 1. )      ! Lateral boundary conditions
+#else
       CALL lbc_lnk_multi( 'dommsk', umask, 'U', 1., vmask, 'V', 1., fmask, 'F', 1. )      ! Lateral boundary conditions
+#endif
  
       ! Ocean/land mask at wu-, wv- and w points    (computed from tmask)
@@ -198,5 +206,9 @@
             &                   tmask(ji,jj  ,1), tmask(ji+1,jj  ,1)   )
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dommsk', ssfmask, 'F', 1._wp )   
+#else
       CALL lbc_lnk( 'dommsk', ssfmask, 'F', 1._wp )   
+#endif
 
 !!an
@@ -279,5 +291,9 @@
          DEALLOCATE( zwf )
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'dommsk', fmask, 'F', 1._wp )      ! Lateral boundary conditions on fmask
+#else
          CALL lbc_lnk( 'dommsk', fmask, 'F', 1._wp )      ! Lateral boundary conditions on fmask
+#endif
          !
          ! CAUTION : The fmask may be further modified in dyn_vor_init ( dynvor.F90 ) depending on ln_vorlat
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/domvvl.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/domvvl.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/domvvl.F90	(revision 13906)
@@ -520,9 +520,17 @@
          !                       ! d - thickness diffusion transport: boundary conditions
          !                             (stored for tracer advction and continuity equation)
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', un_td , 'U' , -1._wp, vn_td , 'V' , -1._wp)
+#else
          CALL lbc_lnk_multi( 'domvvl', un_td , 'U' , -1._wp, vn_td , 'V' , -1._wp)
+#endif
 
          ! 4 - Time stepping of baroclinic scale factors
          ! ---------------------------------------------
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', tilde_e3t_a(:,:,:), 'T', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', tilde_e3t_a(:,:,:), 'T', 1._wp )
+#endif
          tilde_e3t_a(:,:,:) = tilde_e3t_b(:,:,:) + rDt * tmask(:,:,:) * tilde_e3t_a(:,:,:)
 
@@ -1016,5 +1024,9 @@
                &                   + e1e2t(ji+1,jj) * pssh(ji+1,jj)  ) * r1_hu_0(ji,jj) * r1_e1e2u(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', zc3(:,:), 'U', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', zc3(:,:), 'U', 1._wp )
+#endif
          !
          DO jk = 1, jpkm1
@@ -1027,5 +1039,9 @@
                &                   + e1e2t(ji,jj+1) * pssh(ji,jj+1)  ) * r1_hv_0(ji,jj) * r1_e1e2v(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', zc3(:,:), 'V', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', zc3(:,:), 'V', 1._wp )
+#endif
          !
          DO jk = 1, jpkm1
@@ -1040,5 +1056,9 @@
                &                    + e1e2t(ji+1,jj+1) * pssh(ji+1,jj+1)  ) * r1_hf_0(ji,jj) * r1_e1e2f(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', zc3(:,:), 'F', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', zc3(:,:), 'F', 1._wp )
+#endif
          !
          DO jk = 1, jpkm1                    ! Horizontal interpolation of e3f from ssh
@@ -1059,5 +1079,9 @@
                &                   + e1e2t(ji+1,jj) * pssh(ji+1,jj)  ) * r1_hu_0(ji,jj) * r1_e1e2u(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', zc3(:,:), 'U', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', zc3(:,:), 'U', 1._wp )
+#endif
          !
          DO jk = 1, jpk
@@ -1070,5 +1094,9 @@
                &                   + e1e2t(ji,jj+1) * pssh(ji,jj+1)  ) * r1_hv_0(ji,jj) * r1_e1e2v(ji,jj)
          END_2D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'domvvl', zc3(:,:), 'V', 1._wp )
+#else
          CALL lbc_lnk( 'domvvl', zc3(:,:), 'V', 1._wp )
+#endif
           !
          DO jk = 1, jpk
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynatf.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynatf.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynatf.F90	(revision 13906)
@@ -165,5 +165,9 @@
 # endif
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dynatf', puu(:,:,:,Kaa), 'U', -1., pvv(:,:,:,Kaa), 'V', -1. )     !* local domain boundaries
+#else
       CALL lbc_lnk_multi( 'dynatf', puu(:,:,:,Kaa), 'U', -1., pvv(:,:,:,Kaa), 'V', -1. )     !* local domain boundaries
+#endif
       !
       !                                !* BDY open boundaries
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynkeg.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynkeg.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynkeg.F90	(revision 13906)
@@ -133,5 +133,9 @@
             zhke(ji,jj,jk) = r1_48 * ( zv + zu )
          END_3D
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'dynkeg', zhke, 'T', 1. )
+#else
          CALL lbc_lnk( 'dynkeg', zhke, 'T', 1. )
+#endif
          !
       END SELECT 
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynldf_lap_blp.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynldf_lap_blp.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynldf_lap_blp.F90	(revision 13906)
@@ -232,5 +232,9 @@
       CALL dyn_ldf_lap( kt, Kbb, Kmm, pu, pv, zulap, zvlap, 1 )   ! rotated laplacian applied to pt (output in zlap,Kbb)
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dynldf_lap_blp', zulap, 'U', -1., zvlap, 'V', -1. )             ! Lateral boundary conditions
+#else
       CALL lbc_lnk_multi( 'dynldf_lap_blp', zulap, 'U', -1., zvlap, 'V', -1. )             ! Lateral boundary conditions
+#endif
       !
       CALL dyn_ldf_lap( kt, Kbb, Kmm, zulap, zvlap, pu_rhs, pv_rhs, 2 )   ! rotated laplacian applied to zlap (output in pt(:,:,:,:,Krhs))
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynvor.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynvor.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/dynvor.F90	(revision 13906)
@@ -242,5 +242,9 @@
             ENDIF
          END DO
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'dynvor', zwz, 'F', 1. )
+#else
          CALL lbc_lnk( 'dynvor', zwz, 'F', 1. )
+#endif
          !
       END SELECT
@@ -599,5 +603,9 @@
       END DO                                           !   End of slab
          !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dynvor', zwz, 'F', 1. )
+#else
       CALL lbc_lnk( 'dynvor', zwz, 'F', 1. )
+#endif
 
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -720,5 +728,9 @@
       END DO
       !
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'dynvor', zwz, 'F', 1. )
+#else
       CALL lbc_lnk( 'dynvor', zwz, 'F', 1. )
+#endif
       !
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -812,5 +824,9 @@
          END_3D
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'dynvor', fmask, 'F', 1._wp )      ! Lateral boundary conditions on fmask
+#else
          CALL lbc_lnk( 'dynvor', fmask, 'F', 1._wp )      ! Lateral boundary conditions on fmask
+#endif
          !
       ENDIF
@@ -850,5 +866,9 @@
                dj_e1v_2(ji,jj) = ( e1v(ji,jj) - e1v(ji  ,jj-1) ) * 0.5_wp
             END_2D
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'dynvor', di_e2u_2, 'T', -1. , dj_e1v_2, 'T', -1. )   ! Lateral boundary conditions
+#else
             CALL lbc_lnk_multi( 'dynvor', di_e2u_2, 'T', -1. , dj_e1v_2, 'T', -1. )   ! Lateral boundary conditions
+#endif
             !
          CASE DEFAULT                        !* F-point metric term :   pre-compute di(e2u)/(2*e1e2f) and dj(e1v)/(2*e1e2f)
@@ -858,5 +878,9 @@
                dj_e1u_2e1e2f(ji,jj) = ( e1u(ji  ,jj+1) - e1u(ji,jj) )  * 0.5 * r1_e1e2f(ji,jj)
             END_2D
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'dynvor', di_e2v_2e1e2f, 'F', -1. , dj_e1u_2e1e2f, 'F', -1. )   ! Lateral boundary conditions
+#else
             CALL lbc_lnk_multi( 'dynvor', di_e2v_2e1e2f, 'F', -1. , dj_e1u_2e1e2f, 'F', -1. )   ! Lateral boundary conditions
+#endif
          END SELECT
          !
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/ldfdyn.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/ldfdyn.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/ldfdyn.F90	(revision 13906)
@@ -426,5 +426,9 @@
          ENDIF
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfdyn', ahmt, 'T', 1.,  ahmf, 'F', 1. )
+#else
          CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1.,  ahmf, 'F', 1. )
+#endif
          !
          !
@@ -458,5 +462,9 @@
             END DO
             !
+#if defined key_mpi3
+            CALL lbc_lnk_nc_multi( 'ldfdyn', dtensq, 'T', 1. )  ! lbc_lnk on dshesq not needed
+#else
             CALL lbc_lnk_multi( 'ldfdyn', dtensq, 'T', 1. )  ! lbc_lnk on dshesq not needed
+#endif
             !
             DO jk = 1, jpkm1
@@ -509,5 +517,9 @@
          ENDIF
          !
+#if defined key_mpi3
+         CALL lbc_lnk_nc_multi( 'ldfdyn', ahmt, 'T', 1. , ahmf, 'F', 1. )
+#else
          CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1. , ahmf, 'F', 1. )
+#endif
          !
       END SELECT
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/sbcice_cice.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/sbcice_cice.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/sbcice_cice.F90	(revision 13906)
@@ -224,5 +224,9 @@
       END_2D
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', fr_iu , 'U', 1.,  fr_iv , 'V', 1. )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', fr_iu , 'U', 1.,  fr_iv , 'V', 1. )
+#endif
 
       ! set the snow+ice mass
@@ -510,5 +514,9 @@
          ss_iou(ji,jj) = 0.5 * ( ztmp1(ji,jj-1) + ztmp1(ji,jj) ) * umask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', ss_iou , 'U', -1. )
+#else
       CALL lbc_lnk( 'sbcice_cice', ss_iou , 'U', -1. )
+#endif
 
 ! y comp of ocean-ice stress 
@@ -520,5 +528,9 @@
          ss_iov(ji,jj) = 0.5 * ( ztmp1(ji-1,jj) + ztmp1(ji,jj) ) * vmask(ji,jj,1)
       END_2D
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', ss_iov , 'V', -1. )
+#else
       CALL lbc_lnk( 'sbcice_cice', ss_iov , 'V', -1. )
+#endif
 
 ! x and y comps of surface stress
@@ -573,5 +585,9 @@
       fmmflx(:,:) = ztmp1(:,:) !!Joakim edit
       
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', emp , 'T', 1., sfx , 'T', 1. )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', emp , 'T', 1., sfx , 'T', 1. )
+#endif
 
 ! Solar penetrative radiation and non solar surface heat flux
@@ -599,5 +615,9 @@
 #endif
       qsr(:,:)=qsr(:,:)+ztmp1(:,:)
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', qsr , 'T', 1. )
+#else
       CALL lbc_lnk( 'sbcice_cice', qsr , 'T', 1. )
+#endif
 
       DO_2D( 1, 1, 1, 1 )
@@ -612,5 +632,9 @@
       qns(:,:)=qns(:,:)+nfrzmlt(:,:)+ztmp1(:,:)
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', qns , 'T', 1. )
+#else
       CALL lbc_lnk( 'sbcice_cice', qns , 'T', 1. )
+#endif
 
 ! Prepare for the following CICE time-step
@@ -630,5 +654,9 @@
       END_2D
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', fr_iu , 'U', 1., fr_iv , 'V', 1. )
+#else
       CALL lbc_lnk_multi( 'sbcice_cice', fr_iu , 'U', 1., fr_iv , 'V', 1. )
+#endif
 
       ! set the snow+ice mass
@@ -852,5 +880,9 @@
 !     A. Ensure all haloes are filled in NEMO field (pn)
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', pn , cd_type, psgn )
+#else
       CALL lbc_lnk( 'sbcice_cice', pn , cd_type, psgn )
+#endif
 
 #if defined key_nemocice_decomp
@@ -1027,5 +1059,9 @@
 !     D. Ensure all haloes are filled in pn
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'sbcice_cice', pn , cd_type, psgn )
+#else
       CALL lbc_lnk( 'sbcice_cice', pn , cd_type, psgn )
+#endif
 
    END SUBROUTINE cice2nemo
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/step.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/step.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/step.F90	(revision 13906)
@@ -237,6 +237,11 @@
 
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'stp', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
+         &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#else
       CALL lbc_lnk_multi( 'stp', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
          &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#endif
 
 !!an         
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stepLF.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stepLF.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stepLF.F90	(revision 13906)
@@ -248,6 +248,11 @@
 
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'stp', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
+         &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#else
       CALL lbc_lnk_multi( 'stp', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
          &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#endif
 
 !!an         
Index: NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stpRK3.F90
===================================================================
--- NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stpRK3.F90	(revision 13901)
+++ NEMO/branches/2020/dev_r13898_Tiling_Cleanup_MPI3/src/SWE/stpRK3.F90	(revision 13906)
@@ -308,6 +308,11 @@
 
 
+#if defined key_mpi3
+      CALL lbc_lnk_nc_multi( 'stp_RK3', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
+         &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#else
       CALL lbc_lnk_multi( 'stp_RK3', uu(:,:,:,Nnn), 'U', -1., vv(:,:,:,Nnn), 'V', -1.,   &   !* local domain boundaries
          &                       uu(:,:,:,Naa), 'U', -1., vv(:,:,:,Naa), 'V', -1.    )     
+#endif
 
 !!an         