Index: utils/CI/sette_MPI3_LoopFusion/README.rst
===================================================================
--- utils/CI/sette_MPI3_LoopFusion/README.rst	(revision 13938)
+++ utils/CI/sette_MPI3_LoopFusion/README.rst	(revision 13943)
@@ -53,4 +53,13 @@
                                 "yes" to run in MPMD (detached) mode with stand-alone IO servers.
                                 "no"  to run in SPMD (attached) mode without separate IO servers. 
+        # MPI communication management
+          |  USING_MPI3        : flag to control the activation of key_mpi3
+                                "yes" to use the MPI3 neighbourhood collectives for halo exchange
+                                "no" to use standard point-to-point communications for halo exchange
+        # loop fusion management
+          |  USING_LOOP_FUSION : flag to control the activation of key_loop_fusion
+                                "yes" to use the loop fusion adv routines when halo = 2
+                                "no" to use standard adv routine
+
         # generique batch scrip prefix name if MPMD set to true/false
            | JOB_PREFIX_MPMD
Index: utils/CI/sette_MPI3_LoopFusion/param.cfg
===================================================================
--- utils/CI/sette_MPI3_LoopFusion/param.cfg	(revision 13938)
+++ utils/CI/sette_MPI3_LoopFusion/param.cfg	(revision 13943)
@@ -8,5 +8,5 @@
 # ------------------------------------------------------------------------------------------
 # IMPORTANT:
-# variables (COMPILER, USING_XIOS, USING_MPMD, BATCH_CMD, BATCH_STAT, BATCH_NAME, FORCING_DIR, SVN_CMD, ADD_NOSIGNEDZERO)
+# variables (COMPILER, USING_XIOS, USING_MPMD, USING_MPI3, USING_LOOP_FUSION, BATCH_CMD, BATCH_STAT, BATCH_NAME, FORCING_DIR, SVN_CMD, ADD_NOSIGNEDZERO)
 # can be exported from your shell startup files. 
 # If it is the case, nothing to do
@@ -51,4 +51,12 @@
 # MPMD
 USING_MPMD=${SETTE_MPMD:-"no"}
+# USING_MPI3        : flag to control the activation of key_mpi3
+#                     "yes" to use the MPI3 neighbourhood collectives for halo exchange
+#                     "no" to use standard point-to-point communications for halo exchange
+USING_MPI3=${SETTE_MPI3:-"no"}
+# USING_LOOP_FUSION : flag to control the activation of key_loop_fusion
+#                     "yes" to use the loop fusion adv routines when halo = 2
+#                     "no" to use standard adv routines
+USING_LOOP_FUSION=${SETTE_LOOP_FUSION:-"no"}
 # generique batch scrip prefix name if MPMD set to true/false
 JOB_PREFIX_MPMD=${SETTE_JOB_PREFIX_MPMD:-batch-mpmd}
Index: utils/CI/sette_MPI3_LoopFusion/sette_reference-configurations.sh
===================================================================
--- utils/CI/sette_MPI3_LoopFusion/sette_reference-configurations.sh	(revision 13938)
+++ utils/CI/sette_MPI3_LoopFusion/sette_reference-configurations.sh	(revision 13943)
@@ -41,4 +41,10 @@
 # NUM_XIOSERVERS    : number of stand-alone IO servers to employ
 #                     set to zero if USING_MPMD="no"
+# USING_MPI3        : flag to control the activation of key_mpi3
+#                     "yes" to use the MPI3 neighbourhood collectives for halo exchange
+#                     "no" to use standard point-to-point communications for halo exchange
+# USING_LOOP_FUSION : flag to control the activation of key_loop_fusion
+#                     "yes" to use the loop fusion adv routines when halo = 2
+#                     "no" to use standard adv routines
 #
 # Principal script is sette.sh, that calls 
@@ -121,4 +127,14 @@
  else
    export DEL_KEYS="${DEL_KEYS} key_nosignedzero" 
+fi
+#
+if [ ${USING_MPI3} == "yes" ]
+ then
+   export ADD_KEYS="${ADD_KEYS} key_mpi3"
+fi
+#
+if [ ${USING_LOOP_FUSION} == "yes" ]
+ then
+   export ADD_KEYS="${ADD_KEYS} key_loop_fusion"
 fi
 #
Index: utils/CI/sette_MPI3_LoopFusion/sette_test-cases.sh
===================================================================
--- utils/CI/sette_MPI3_LoopFusion/sette_test-cases.sh	(revision 13938)
+++ utils/CI/sette_MPI3_LoopFusion/sette_test-cases.sh	(revision 13943)
@@ -40,4 +40,10 @@
 # NUM_XIOSERVERS    : number of stand-alone IO servers to employ
 #                     set to zero if USING_MPMD="no"
+# USING_MPI3        : flag to control the activation of key_mpi3
+#                     "yes" to use the MPI3 neighbourhood collectives for halo exchange
+#                     "no" to use standard point-to-point communications for halo exchange
+# USING_LOOP_FUSION : flag to control the activation of key_loop_fusion
+#                     "yes" to use the loop fusion adv routines when halo = 2
+#                     "no" to use standard adv routines
 #
 # Principal script is sette_test-cases.sh, that calls 
@@ -120,4 +126,13 @@
 fi
 #
+if [ ${USING_MPI3} == "yes" ]
+ then
+   export ADD_KEYS="${ADD_KEYS} key_mpi3"
+fi
+#
+if [ ${USING_LOOP_FUSION} == "yes" ]
+ then
+   export ADD_KEYS="${ADD_KEYS} key_loop_fusion"
+fi
 # Settings which control the use of stand alone servers (only relevant if using xios)
 #