Index: /NEMO/branches/2020/SI3_vp_rheology/cfgs/SHARED/namelist_ice_ref
===================================================================
--- /NEMO/branches/2020/SI3_vp_rheology/cfgs/SHARED/namelist_ice_ref	(revision 13966)
+++ /NEMO/branches/2020/SI3_vp_rheology/cfgs/SHARED/namelist_ice_ref	(revision 13967)
@@ -104,7 +104,7 @@
                                       !          this option 2 asks a lot of communications between cpu
    ln_rhg_VP        = .false.         !  VP rheology
-   nn_vp_nout       = 10              !     number of outer iterations
-   nn_vp_ninn       = 1500            !     number of inner iterations
-   nn_vp_cvgchk     = 5               !     iteration step for convergence check
+      nn_vp_nout    = 10              !     number of outer iterations
+      nn_vp_ninn    = 1500            !     number of inner iterations
+      nn_vp_cvgchk  = 5               !     iteration step for convergence check
 /
 !------------------------------------------------------------------------------
Index: /NEMO/branches/2020/SI3_vp_rheology/src/ICE/icedyn_rhg_vp.F90
===================================================================
--- /NEMO/branches/2020/SI3_vp_rheology/src/ICE/icedyn_rhg_vp.F90	(revision 13966)
+++ /NEMO/branches/2020/SI3_vp_rheology/src/ICE/icedyn_rhg_vp.F90	(revision 13967)
@@ -145,5 +145,5 @@
       INTEGER ::   nn_nvp              ! total number of VP iterations (n_out_vp*n_inn_vp)      
       !
-      REAL(wp) ::   zrhoco                                              ! rau0 * rn_cio
+      REAL(wp) ::   zrhoco                                              ! rho0 * rn_cio
       REAL(wp) ::   ecc2, z1_ecc2                                       ! square of yield ellipse eccenticity
       REAL(wp) ::   zglob_area                                          ! global ice area for diagnostics
@@ -255,5 +255,5 @@
       IF( lwp )   WRITE(numout,*) ' nn_nvp      : ', nn_nvp
       
-      zrhoco = rau0 * rn_cio 
+      zrhoco = rho0 * rn_cio 
 
       ! ecc2: square of yield ellipse eccentricity
@@ -262,5 +262,5 @@
                
       ! Initialise convergence checks
-      IF( ln_rhg_chkcvg ) THEN
+      IF( nn_rhg_chkcvg /= 0 ) THEN
       
          ! ice area for global mean kinetic energy
@@ -362,6 +362,6 @@
                           
             ! Mass per unit area divided by time step
-            zmassU_t(ji,jj) = zmassU * r1_rdtice
-            zmassV_t(ji,jj) = zmassV * r1_rdtice
+            zmassU_t(ji,jj) = zmassU * r1_Dt_ice
+            zmassV_t(ji,jj) = zmassV * r1_Dt_ice
 
             ! Acceleration term contribution to RHS (depends on velocity at previous time step)            
@@ -1033,5 +1033,5 @@
                zuerr_max = 0._wp
                                
-               IF ( ll_u_iterate .AND. MOD ( i_inn, nn_cvgchk_vp ) == 0 ) THEN
+               IF ( ll_u_iterate .AND. MOD ( i_inn, nn_vp_cvgchk ) == 0 ) THEN
 
                   ! - Maximum U-velocity difference               
@@ -1064,5 +1064,5 @@
                zverr_max = 0._wp
                
-               IF ( ll_v_iterate .AND. MOD ( i_inn, nn_cvgchk_vp ) == 0 ) THEN
+               IF ( ll_v_iterate .AND. MOD ( i_inn, nn_vp_cvgchk ) == 0 ) THEN
                
                   ! - Maximum V-velocity difference
@@ -1099,5 +1099,5 @@
             !---------------------------------------------------------------------------------------
 
-            IF( ln_rhg_chkcvg .AND. MOD ( i_inn - 1, nn_cvgchk_vp ) == 0 ) CALL rhg_cvg_vp( kt, jter, nn_nvp, u_ice, v_ice, zmt, zuerr_max, zverr_max, zglob_area, &
+            IF( nn_rhg_chkcvg/=0 .AND. MOD ( i_inn - 1, nn_vp_cvgchk ) == 0 ) CALL rhg_cvg_vp( kt, jter, nn_nvp, u_ice, v_ice, zmt, zuerr_max, zverr_max, zglob_area, &
                       &                         zrhsu, zAU, zBU, zCU, zDU, zEU, zrhsv, zAV, zBV, zCV, zDV, zEV )
 
@@ -1137,5 +1137,5 @@
       !------------------------------------------------------------------------------!
 
-      IF( ln_rhg_chkcvg ) THEN
+      IF( nn_rhg_chkcvg /= 0 ) THEN
           
          IF( iom_use('uice_cvg')  ) THEN
@@ -1144,5 +1144,5 @@
          ENDIF   
         
-      ENDIF ! ln_rhg_chkcvg
+      ENDIF
 
       ! MV DEBUG test - replace ice velocity by ocean current to give the model the means to go ahead